package nccloud.web.hrcm.contopinion.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import nc.hr.utils.ResHelper;
import nc.itf.hrcm.IContopinionManageService;
import nc.pub.tools.HRCMCommonValue;
import nc.vo.hrcm.contopinion.ContopinionVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.BusinessRuntimeException;
import nc.vo.uif2.LoginContext;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * ͬǩѯǩѯϢ
 * @author tianxfc
 *
 */
public class OpinionRemcSendMsgAction extends HRCommonAction{
	
	private Integer	icntsucc = 0;	// ɹ͵Ϣ
	
	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		LoginContext context = HRNccUtils.getLoginContext(param);
		
		String pk_org = param.getString("pk_org", null);
		if(StringUtils.isEmpty(pk_org)){
			throw new BusinessRuntimeException(ResHelper.getString("6001uif2", "06001uif20070")/* @res ѡԴ֯ */);
		}
		// ǷͱʶһεýӿڴNڶεýӿڴY
		String sendCheckStr = param.getString("sendCheck", "Y");
        boolean sendCheck = "Y".equals(sendCheckStr);
		ContopinionVO[] selDatas = HRNccTemplateUtils.getVOFromGrid(ContopinionVO.class, OpinionCommon.getModelStr(param, "contopiniongrid"));
		if(ArrayUtils.isEmpty(selDatas)){
			throw new BusinessRuntimeException(ResHelper.getString("6011opin", "06011opin0025")/* @res"ѡҪļ¼" */);
		}
		return sendContOpinion(selDatas, context, sendCheck);
	}
	
	private String sendContOpinion(ContopinionVO[] contopinionVOs, LoginContext context, boolean sendCheck) throws Exception {
		/**δѯδǩ*/
		ArrayList<ContopinionVO> vtemp = new ArrayList<ContopinionVO>();
		/**еǩ*/
		ArrayList<ContopinionVO> inFeedbackList = new ArrayList<ContopinionVO>();
		for (int i = 0; i < contopinionVOs.length; i++) {
			// conttype: : 0=δѯ1=δ2=У3=ѷ4=ǩ5=ֹ
			if (contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_NOCONSULT) || contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_NOFEEDBACK)) {
				vtemp.add(contopinionVOs[i]);
			}
			//modify by@chenzf ǩѯԱǩ 2021-1-11 17:21:49 begin
//			if(contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_INFEEDBACK)){
//				inFeedbackList.add(contopinionVOs[i]);
//			}
			if(contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_INFEEDBACK) || contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_NOCONSULT) || contopinionVOs[i].getConttype().equals(HRCMCommonValue.STATE_NOFEEDBACK)){
				inFeedbackList.add(contopinionVOs[i]);
			}
			//modify by@chenzf ǩѯԱǩ 2021-1-11 17:21:49 end
		}
		if (vtemp.size() < 1 && inFeedbackList.size() < 1) {
			throw new BusinessException(ResHelper.getString("6011opin", "06011opin0008")/* @res"ֻδδѯеԱܷ֪ͨ" */);
		}
		// УǷڷѯļ¼
		HashMap<String, Object> map = ServiceLocator.find(IContopinionManageService.class).getPsnjobDeptMap(vtemp.toArray(new ContopinionVO[0]));
		String[] deptPKs = (String[]) map.get("pks");

		String msg=null;
		if(inFeedbackList.size()<1){
			msg = (String) map.get("msg");
			//еΪ0δݣδѯδĶûвŸʱѯ
			if(ArrayUtils.isEmpty(deptPKs)){
				throw new BusinessException(ResHelper.getString("6011opin", "06011opin0019"));
			}
		}else if(ArrayUtils.isEmpty(deptPKs) || deptPKs.length < 1){
			//ֻз
			/*"ѡеĲԱĴ״̬ΪСϵͳԱѯ֪߰ͨȷϷ"*/;
			msg = ResHelper.getString("6011opin", "06011opin0060");
		}else{
			//ͬʱкδ
			/*"ѡеԱĴ״̬δ͡СϵͳԱĲŸ˻Աѯ֪ͨȷϷ"*/
			msg = ResHelper.getString("6011opin", "06011opin0061");
		}
		
		if(msg != null) {
//			msg = "ã빫˾Ͷͬڣǩ޹̶ͶͬͶͬ͡޹̶/̶";
		}
		
		// Ƿͱʶһεýӿfalseڶεýӿtrue
		if(sendCheck){
			return ResHelper.getString("6011opin", "06011opin0057")/* @res "ȷϷ" */ + "\n" + msg;
//			return msg;
		}
		ContopinionVO[] vos = (ContopinionVO[]) map.get("vos");
		HashMap<String, List<ContopinionVO>> contopMap = new HashMap<String, List<ContopinionVO>>();
		HashMap<String, List<String>> psndeptMap = new HashMap<String, List<String>>();
		if(!ArrayUtils.isEmpty(deptPKs)){			
			for(int i = 0; i < deptPKs.length; i++){// һһӦ֪ͨ
				List<ContopinionVO> depttemp = new ArrayList<ContopinionVO>();
				List<String> psndocList = new ArrayList<String>();
				for(ContopinionVO vo : vos){
					if(vo.getPk_dept().equals(deptPKs[i])){
						depttemp.add(vo);
						psndocList.add(vo.getPk_psnjob());
					}
				}
				contopMap.put(deptPKs[i], depttemp);
				psndeptMap.put(deptPKs[i], psndocList);
			}
		}

		//modify by@chenzf ǩѯԱǩ 2021-1-11 17:21:49 begin
//		HashMap<String, Object> sendMsgMap = ServiceLocator.find(IContopinionManageService.class)
//				.sendNoticeToDeptManager(psndeptMap, contopMap, context.getPk_group(), context.getPk_org(), vos, inFeedbackList);
		HashMap<String, Object> sendMsgMap = ServiceLocator.find(IContopinionManageService.class)
				.sendNoticeToPsn(psndeptMap, contopMap, context.getPk_group(), context.getPk_org(), vos, inFeedbackList);
		//modify by@chenzf ǩѯԱǩ 2021-1-11 17:21:49 end
		icntsucc = (Integer) sendMsgMap.get("cnt");
		if(icntsucc > 0){
			// ʾͳɹϢ
			return ResHelper.getString("6011opin", "06011opin0010"/* @res "Ϣɹ,Ϣ[{0}]" */, icntsucc.toString());
		}else{
			// ͲɹʾϢ
			throw new BusinessException(ResHelper.getString("6011opin", "06011opin0011")/* @res "Ϣʧܣ" */);
		}
	}
	
}
