package nc.ui.wa.ref;

import nc.bs.logging.Logger;
import nc.hr.utils.ResHelper;
import nc.ui.bd.ref.AbstractRefModel;
import nc.vo.pub.BusinessException;
import nc.vo.util.VisibleUtil;
import nc.vo.wa.grade.WaGradeVO;

import nccloud.commons.lang.StringUtils;
/**
 * н׼ģ
 *
 * @author: xuhw
 * @date: 2009-11-17 12:56:56
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public class WaGradeExRefModel extends AbstractRefModel
{
	/**
	 * нʱ׼
	 */
	public final static String WA_GRADE_BEAN_ID = "92054d71-866d-4d82-9085-75ad2f63d4c1";
	/**
	 * нĿ
	 */
	private String strPkItem;

	public WaGradeExRefModel(String pk_item, String strPKOrg)
	{
		super();
		this.setTableName(" wa_grade ");
		this.setFieldCode(new String[]
		{ "code", "name", "vmemo" });
		this.setFieldName(new String[]
		{ ResHelper.getString("6013commonbasic","06013commonbasic0043")/*@res "нʱ׼"*/, ResHelper.getString("6013commonbasic","06013commonbasic0044")/*@res "нʱ׼"*/, ResHelper.getString("common","UC000-0003660")/*@res "˵"*/ });
		this.setPkFieldCode("pk_wa_grd");
		this.setHiddenFieldCode(new String[]
		{ "pk_wa_grd", "pk_group", "pk_org", "ismultsec" ,WaGradeVO.ISRANGE});
		this.setDefaultFieldCount(4);
		this.setRefTitle(ResHelper.getString("6013commonbasic","06013commonbasic0045")/*@res "н׼"*/);
		this.setStrPkItem(pk_item);
		setRefCodeField("name");
		setRefNameField("name");
//		begin 20150723 xiejie3 յĻֵbd_refinfonameֵֶĿǰܶյrefModelûRefNodeNameֵ
		setRefNodeName("нʱ׼"); /*-=notranslate=-*/
//		end
	}

	public WaGradeExRefModel()
	{
		super();
		this.setTableName(" wa_grade ");
		this.setFieldCode(new String[]
		{ "code", "name", "vmemo" });
		this.setFieldName(new String[]
	    // 2015-09-06 zhousze нĿнʷĿнʱ׼ʱͷʾ⣬ҪǶ·
	    // пո begin
		{ ResHelper.getString("6013commonbasic","06013commonbasic0043")/*@res "нʱ׼"*/, ResHelper.getString("6013commonbasic","06013commonbasic0044")/*@res "нʱ׼"*/, ResHelper.getString("common","UC000-0003660")/*@res "˵"*/ });
		// 2015-09-06 zhousze нĿнʷĿнʱ׼ʱͷʾ⣬ҪǶ·
		// пո end
		this.setPkFieldCode("pk_wa_grd");
		this.setHiddenFieldCode(new String[]
		{ "pk_wa_grd", "pk_group", "pk_org", "ismultsec",WaGradeVO.ISRANGE });
		this.setDefaultFieldCount(3);
		this.setRefTitle(ResHelper.getString("6013commonbasic","06013commonbasic0045")/*@res "н׼"*/);
		setRefCodeField("name");
		setRefNameField("name");
//		begin 20150723 xiejie3 յĻֵbd_refinfonameֵֶĿǰܶյrefModelûRefNodeNameֵ
		setRefNodeName("нʱ׼"); /*-=notranslate=-*/
//		end
		
	}

	/**
	 * ƴдsql<BR>
	 * 5ϵȥ<BR>
	 * ͱصĹ<BR>
	 * bd_currtype.dr=0 and wa_grade.pk_currtype = bd_currtype.pk_currtype
	 *
	 * @author xuhw on 2009-11-20
	 * @see nc.ui.bd.ref.AbstractRefModel#getEnvWherePart()
	 */
	@Override
	protected String getEnvWherePart()
	{
		StringBuffer sbWhere = new StringBuffer();

		sbWhere.append(" wa_grade.pk_wa_grd in (select pk_wa_grd from wa_grade_ver where effect_flag = 'Y') and wa_grade.standard_type = 1");
		
		if (!StringUtils.isBlank(getStrPkItem()))
		{
			sbWhere.append(" wa_grade.pk_wa_item = '" + getStrPkItem() + "' and ");
		}
		
		

		try
		{
			return sbWhere.toString() + " " + VisibleUtil.getRefVisibleCondition(getPk_group(), getPk_org(), WA_GRADE_BEAN_ID) + "";
		}
		catch (BusinessException e)
		{
			Logger.error(e.getMessage(), e);
		}

		if (StringUtils.isBlank(sbWhere.toString()))
		{
			return null;
		}
		else
		{
			return sbWhere.toString();
		}

	}

	public String getStrPkItem()
	{
		return strPkItem;
	}

	public void setStrPkItem(String strPkItem)
	{
		this.strPkItem = strPkItem;
	}
}