package nc.ui.wa.ruleex.action;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import nc.bs.logging.Logger;
import nc.hr.utils.CommonUtils;
import nc.hr.utils.ResHelper;
import nc.ui.hr.uif2.action.AddAction;
import nc.ui.hr.uif2.action.HrActionInterceptor;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.uif2.ShowStatusBarMsgUtil;
import nc.ui.uif2.model.AbstractAppModel;
import nc.vo.bd.pub.NODE_TYPE;
import nc.vo.pub.BusinessException;
import nc.vo.uif2.LoginContext;
import nc.vo.util.ManageModeUtil;

/**
 * WaRuleManagerModelCheckInterceptor<BR>
 * ޸ģɾ action <BR>
 * @author: xuhw
 * @date: 2009-11-16 03:33:47
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public class WaRuleManagerModelCheckInterceptor extends HrActionInterceptor
{
	private AbstractAppModel appModel;

	/**
	 * ޸ģɾǰУ<BR>
	 * 1)֯ĽڵǷѡԴ֯<BR>
	 * <BR>
	 * 2)ܿģʽУ<BR>
	 * @author xuhw on 2009-11-16
	 */
	@Override
	public boolean beforeDoAction(Action action, ActionEvent e)
	{
		LoginContext context = getAppModel().getContext();


		//ǷѾѡԴ֯Դ֯
		try
		{
			if (context.getNodeType() != NODE_TYPE.GROUP_NODE && context.getNodeType() != NODE_TYPE.GROUP_NODE)
			{
				CommonUtils.checkOrg(context);
			}

		}
		catch (BusinessException ex)
		{
			Logger.error(ex.getMessage(), ex);
			MessageDialog.showErrorDlg(context.getEntranceUI(), null, ResHelper.getString("60130payrule","060130payrule0005")/*@res "ѡԴ֯"*/);
			return false;
		}

		//ӵĳ,ûѡݵĳϲйܿģʽУ
		if (action instanceof AddAction || action instanceof WaRuleCopyTableAction || getAppModel().getSelectedData() == null)
		{
			return true;
		}

		//ܿģʽУ
		boolean blnIsCanOperator = ManageModeUtil.manageable(getAppModel().getSelectedData(), context);
		if (!blnIsCanOperator)
		{
			//MessageDialog.showErrorDlg(context.getEntranceUI(), null, ManageModeUtil.getDisManageableMsg(context.getNodeType()));
			ShowStatusBarMsgUtil.showErrorMsg(ResHelper.getString("60130payrule","060130payrule0018")/*@res "ʧܣ"*/
					, ManageModeUtil.getDisManageableMsg(context.getNodeType()), getContext(action));
			return false;
		}
		return true;
	}

	public AbstractAppModel getAppModel()
	{
		return appModel;
	}

	public void setAppModel(AbstractAppModel appModel)
	{
		this.appModel = appModel;
	}

}