package nccloud.web.hrwa.wagrade.action;

import nc.hr.utils.CommonUtils;
import nc.hr.utils.ResHelper;
import nc.itf.hr.wa.IWaGradeQueryService;
import nc.itf.hr.wa.IWaGradeService;
import nc.vo.bd.pub.NODE_TYPE;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.uif2.LoginContext;
import nc.vo.util.ManageModeUtil;
import nc.vo.wa.grade.AggWaGradeVO;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.hrwa.wagrade.action.util.WaGradeCommon;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * 
 * 4:20:50 
 * msw 
 * нʹӰťʱУ,Уͨtrue,ֱͨ״
 *
 */
public class WaGradeBeforeDoAction extends HRCommonAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		LoginContext context = HRNccUtils.getLoginContext(param);
		String opType = param.getString("op_type", null);// ǰ˱봫add,copy,edit
		if (opType == null) {
			return null;
		}
		if (WaGradeCommon.OPTYPE_LIST.contains(opType)) {
			validata(context, opType, null);
		} else if ("edit".equals(opType) || "delete".equals(opType)) {
			String pkWaGrd = param.getString("pk_wa_grd", null);
			AggWaGradeVO gradeVo = (AggWaGradeVO) ServiceLocator.find(IWaGradeQueryService.class)
					.queryAggWagradeByGrdPK(pkWaGrd);
			validata(context, opType, gradeVo);
		}
		return true;
	}

	/**
	 * 
	 * 20196263:52:31
	 * msw
	 * @param context
	 * @param opType
	 * @param ob
	 * @throws BusinessException
	 *
	 */
	public void validata(LoginContext context, String opType, Object ob) throws BusinessException {
		// ǷѾѡԴ֯Դ֯
		try {
			if (context.getNodeType() != NODE_TYPE.GROUP_NODE && context.getNodeType() != NODE_TYPE.GLOBE_NODE) {
				CommonUtils.checkOrg(context);
			}
		} catch (BusinessException ex) {
			throw new BusinessException(ResHelper.getString("60130payrule",
					"060130payrule0005")/* @res "ѡԴ֯" */);
		}
		// ӵĳ,ûѡݵĳϲйܿģʽУ
		if ("add".equals(opType) || ob == null) {
			return;
		}
		// ܿģʽУ
		boolean blnIsCanOperator = ManageModeUtil.manageable(ob, context);
		if (!blnIsCanOperator) {
			throw new BusinessException(ManageModeUtil.getDisManageableMsg(context.getNodeType()));
		}
        if("edit".equals(opType) || ob == null){
        	AggWaGradeVO gradeVo=(AggWaGradeVO)ob;
			boolean editable = ServiceLocator.find(IWaGradeService.class).validateEffectVersion(gradeVo.getParentVO().getPk_wa_grd());
			if (editable) {
				String sbErrMessage = ResHelper.getString("60130paystd","060130paystd0235")/*@res "нʱ׼ѾЧ޸ģ"*/;
				throw new BusinessException(sbErrMessage);
			}
			
			UFBoolean isgroup = gradeVo.getParentVO().getIsgroup();
			UFBoolean isscope = gradeVo.getParentVO().getIsscope();
			if((isgroup != null && isgroup.booleanValue()) && (isscope == null || !isscope.booleanValue())) {
				throw new BusinessException("ŷݲȷΧ˾ӼΪ񣬲޸");
			}
        }
	}
}
