package nccloud.web.hrwa.waruleex.action;

import nc.hr.utils.CommonUtils;
import nc.hr.utils.ResHelper;
import nc.vo.bd.pub.NODE_TYPE;
import nc.vo.hrwa.waruleex.AggWageformExVO;
import nc.vo.pub.BusinessException;
import nc.vo.uif2.LoginContext;
import nc.vo.util.ManageModeUtil;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;
/**
 * 
 * 4:20:50
 * msw
 * нʹӰťʱУ,Уͨtrue,ֱͨ״
 *
 */
public class WaRuleExBeforeDoAction extends HRCommonAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		LoginContext context = HRNccUtils.getLoginContext(param);
		String opType = param.getString("op_type", null);// ǰ˱봫add,copy,edit
		if (opType == null) {
			return null;
		}
		if ("add".equals(opType) || "copy".equals(opType)) {
			beforeDoAction(context, opType, null);
		} else if ("edit".equals(opType) || "delete".equals(opType)) {
			String pkWaWageform = param.getString("pk_wa_wageformex", null);
			WaRuleExCommon common = new WaRuleExCommon();
			AggWageformExVO aggWageformVO = common.listHandleData(context, pkWaWageform);
			beforeDoAction(context, opType, aggWageformVO);
		}
		return true;
	}
/**
 * 
 * 20196274:47:35
 * msw
 * @param context
 * @param opType
 * @param ob
 * @throws BusinessException
 *
 */
	private void beforeDoAction(LoginContext context, String opType, Object ob) throws BusinessException {
		// ǷѾѡԴ֯Դ֯
		try {
			if (context.getNodeType() != NODE_TYPE.GROUP_NODE && context.getNodeType() != NODE_TYPE.GLOBE_NODE) {
				CommonUtils.checkOrg(context);
			}
		} catch (BusinessException ex) {
			throw new BusinessException(ResHelper.getString("60130payrule",
					"060130payrule0005")/* @res "ѡԴ֯" */);
		}
		// ӵĳ,ûѡݵĳϲйܿģʽУ
		if ("add".equals(opType) || "copy".equals(opType) || ob == null) {
			return;
		}
		// ܿģʽУ
		boolean blnIsCanOperator = ManageModeUtil.manageable(ob, context);
		if (!blnIsCanOperator) {
			throw new BusinessException(ManageModeUtil.getDisManageableMsg(context.getNodeType()));
		}
	}
}
