package nccloud.web.hrwa.waruleex.action;

import nc.itf.hr.wa.IWaRuleExQueryService;
import nc.vo.hrwa.waruleex.AggWageformExVO;
import nc.vo.hrwa.waruleex.WageformExVO;
import nc.vo.pub.BusinessException;
import nc.vo.uif2.LoginContext;
import nccloud.commons.lang.ArrayUtils;
import nccloud.framework.service.ServiceLocator;

public class WaRuleExCommon {
	/**
	 * 
	 * 8:43:13 
	 * msw
	 * @param context
	 * @param pkWwaWageform
	 * @return
	 * @throws BusinessException
	 *
	 */
	public AggWageformExVO listHandleData(LoginContext context, String pkWwaWageform) throws BusinessException {
		AggWageformExVO[] vos = (AggWageformExVO[]) ServiceLocator.find(IWaRuleExQueryService.class).queryWageFormVO(context,
				null);
		if (ArrayUtils.isEmpty(vos)) {
			return null;
		}
		for (int i = 0; i < vos.length; i++) {
			String pk = ((WageformExVO) vos[i].getParentVO()).getPk_wa_wageformex();
			if (pk != null && pk.equals(pkWwaWageform)) {
				return vos[i];
			}
		}
		return null;
	}

}
