/**
 *
 */
package nc.itf.hr.wa;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

import nc.bs.dao.DAOException;
import nc.vo.hr.append.AppendableVO;
import nc.vo.hr.datainterface.FormatItemVO;
import nc.vo.hr.datainterface.HrIntfaceVO;
import nc.vo.hrp.budgetmgt.BudgetWarnMessageVo;
import nc.vo.pub.BusinessException;
import nc.vo.wa.classitem.WaClassItemVO;
import nc.vo.wa.paydata.AggPayDataVO;
import nc.vo.wa.paydata.DataSVO;
import nc.vo.wa.paydata.DataVO;
import nc.vo.wa.paydata.WaClassItemShowInfVO;
import nc.vo.wa.paydata.WaPaydataDspVO;
import nc.vo.wa.payfile.PayfileVO;
import nc.vo.wa.pub.WaLoginContext;
import nc.vo.wa.pub.WaLoginVO;

/**
 * нʷŲѯ
 * 
 * @author: zhangg
 * @date: 2009-11-23 01:19:29
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public interface IPaydataQueryService {

	/**
	 * õûȨ޵ĵнĿ
	 * 
	 * @author zhangg on 2009-12-1
	 * @param loginVO
	 * @return
	 * @throws BusinessException
	 */
	public abstract WaClassItemVO[] getUserClassItemVOs(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * õûȨ޵ĵнĿ
	 * 
	 * @author zhangg on 2009-12-1
	 * @param loginVO
	 * @return
	 * @throws BusinessException
	 */
	public abstract WaClassItemVO[] getUserShowClassItemVOs(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * õûȨ޵ĵнĿ. ǲڼ뱻ڼ䶼еĿ ǲڼǲܻ߲ڼΪգ ѡеĿ
	 * 
	 * @author zhangg on 2009-12-1
	 * @param loginVO
	 * @return
	 * @throws BusinessException
	 */
	public abstract WaClassItemVO[] getRepayUserShowClassItemVOs(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * Ϊרṩķ ͬʱ нʷĿ,нĿչϢ
	 * 
	 * @param loginContext
	 * @return
	 * @throws BusinessException
	 */
	public abstract WaClassItemShowInfVO getWaClassItemShowInfVO(
			WaLoginContext loginContext) throws BusinessException;

	public abstract WaClassItemShowInfVO getWaClassItemShowInfVO4PayLeave(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * õнĿ
	 * 
	 * @author zhangg on 2009-12-1
	 * @param loginVO
	 * @return
	 * @throws BusinessException
	 */
	public abstract WaClassItemVO[] getApprovalClassItemVOs(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * һβѯҪõݣ loginVOн״̬ classItemVOsȨ޵нĿ dataVOsѯн Ŀģ
	 * 
	 * 
	 * @author zhangg on 2009-12-10
	 * @param loginContext
	 * @param condition
	 * @return
	 * @throws BusinessException
	 */
	public abstract AggPayDataVO queryAggPayDataVOByCondition(
			WaLoginContext loginContext, String condition, String orderCondtion)
			throws BusinessException;

	/**
	 * ѯ뵥н Ŀ
	 * 
	 * @author liangxr on 2010-7-2
	 * @param loginContext
	 * @param condition
	 * @param orderCondtion
	 * @return
	 * @throws BusinessException
	 */

	public abstract AggPayDataVO queryAggPayDataVOForroll(
			WaLoginContext loginContext) throws BusinessException;

	public abstract Map<String, AggPayDataVO> queryItemAndSumDataVOForroll(
			WaLoginContext loginContext) throws BusinessException;

	/**
	 * PKѯн
	 * 
	 * @author liangxr on 2010-5-24
	 * @param pk_wa_data
	 * @return
	 * @throws BusinessException
	 */
	public abstract DataVO getDataVOByPk(String pk_wa_data)
			throws BusinessException;

	/**
	 * PKѯн
	 * 
	 * @author liangxr on 2010-5-24
	 * @param pk_wa_data
	 * @return
	 * @throws BusinessException
	 */
	public abstract DataVO[] queryDataVOByPks(String[] pk_wa_data)
			throws BusinessException;

	/**
	 * PKѯн
	 *
	 * @author liangxr on 2010-5-24
	 * @param pk_wa_data
	 * @return
	 * @throws BusinessException
	 */
	public abstract DataVO[] queryDataVOByInsql(String insql)
			throws BusinessException;

	/**
	 * contextѯн
	 * 
	 * @author liangxr on 2010-5-24
	 * @param loginContext
	 * @return
	 * @throws BusinessException
	 */
	public abstract DataSVO[] getDataSVOs(WaLoginContext loginContext)
			throws BusinessException;

	/**
	 * ѯн
	 * 
	 * @author liangxr on 2010-5-24
	 * @param loginContext
	 * @param condition
	 * @param orderCondtion
	 * @return
	 * @throws BusinessException
	 */
	DataVO[] queryDataVOsByCond(WaLoginContext loginContext, String condition,
			String orderCondtion) throws BusinessException;

	
	/**
	 * ǰ̨ѯȽ,ϴ,̨
	 * @param loginContext
	 * @param vo
	 * @param appendVOs
	 * @param itemVOs
	 * @return
	 * @throws Exception
	 */
	public abstract Map<String, AppendableVO> campareDateVOsByCond(WaLoginContext loginContext,
			HrIntfaceVO vo, AppendableVO[] appendVOs, FormatItemVO[] itemVOs)
			throws Exception;

	/**
	 * ϸԱ
	 * 
	 * @author liangxr on 2010-5-24
	 * @param loginVO
	 * @param whereCondition
	 * @return
	 * @throws BusinessException
	 */
	public DataVO[] getContractDataVOs(WaLoginContext loginVO,
			String whereCondition, String orderCondition)
			throws BusinessException;

	/**
	 * ǰǷύ
	 * 
	 * @author liangxr on 2010-6-1
	 * @param waLoginVO
	 * @return
	 * @throws BusinessException
	 */
	boolean isPayrollSubmit(WaLoginVO waLoginVO) throws BusinessException;

	/**
	 * ǰǷ̬
	 * 
	 * @author liangxr on 2010-6-1
	 * @param waLoginVO
	 * @return
	 * @throws BusinessException
	 */
	boolean isPayrollFree(WaLoginVO waLoginVO) throws BusinessException;

	/**
	 * 㵱ǰѡûеԱ
	 * 
	 * @author liangxr on 2010-7-12
	 * @param cacuItem
	 * @param whereStr
	 * @return
	 * @throws BusinessException
	 */
	public BigDecimal getOrgTmSelected(String cacuItem, String whereStr)
			throws BusinessException;

	/**
	 * 㵱ǰѡûеԱ
	 * 
	 * @author liangxr on 2010-7-12
	 * @param cacuItem
	 * @param whereStr
	 * @return
	 * @throws BusinessException
	 */
	public Map<String, BigDecimal> getDeptTmSelected(String cacuItem,
			String whereStr) throws BusinessException;

	/**
	 * ֯㹤ܶ
	 * 
	 * @author liangxr on 2010-7-12
	 * @param cacuItem
	 * @param pk_org
	 * @param accYear
	 * @param pk_wa_class
	 * @return
	 * @throws SQLException
	 */
	public BigDecimal getOrgTm(String cacuItem, String pk_org, String accYear,
			String accPeriod, String pk_wa_class, int sumType)
			throws BusinessException;

	/**
	 * ż㹤ܶ
	 * 
	 * @author liangxr on 2010-7-12
	 * @param cacuItem
	 * @param pk_org
	 * @param accYear
	 * @param accPeriod
	 * @param gzlbId
	 * @return
	 * @throws DAOException
	 */
	public Map<String, BigDecimal> getDeptTm(String cacuItem, String pk_org,
			String accYear, String accPeriod, String gzlbId, int sumType)
			throws BusinessException;

	/**
	 * нܶԤѯӿ
	 * 
	 * @author liangxr on 2010-7-23
	 * @param context
	 * @param whereStr
	 * @return
	 * @throws nc.vo.pub.BusinessException
	 */
	public BudgetWarnMessageVo budgetAlarm4Pay(WaLoginContext context,
			String whereStr) throws nc.vo.pub.BusinessException;

	/**
	 * нʵʾ
	 * 
	 * @param context
	 * @return
	 * @throws BusinessException
	 */
	public List<WaPaydataDspVO> queryPaydataDisplayInfo(WaLoginContext context)
			throws BusinessException;

	/**
	 * ְнʾ
	 * 
	 * @param context
	 * @return
	 * @throws BusinessException
	 */
	public List<WaPaydataDspVO> queryPaydataDisplayInfo4Payleave(
			WaLoginContext context) throws BusinessException;

	/**
	 * ȡʱУְн
	 * 
	 * @param waLoginVO
	 * @param whereCondition
	 * @param isRangeAll
	 * @return
	 * @throws DAOException
	 */
	public PayfileVO[] getInPayLeavePsn(WaLoginVO waLoginVO,
			String whereCondition, boolean isRangeAll) throws BusinessException;

	/**
	 * жһǵλǶΣǶеһΣǷѾŹһΣ
	 * 
	 * @param pk_wa_data
	 * @return
	 * @throws BusinessException
	 */
	public boolean isAnyTimesPayed(String pk_wa_class, String cyear,
			String cperiod) throws BusinessException;

}
