package nc.itf.hr.wa;

import java.util.HashMap;

import nc.vo.hrwa.gradeorg.WaGradeOrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.wa.adjust.AdjustWadocVO;
import nc.vo.wa.adjust.PsnappaproveBVO;
import nc.vo.wa.grade.AggWaGradeVO;
import nc.vo.wa.grade.WaCriterionVO;
import nc.vo.wa.grade.WaGradeVO;
import nc.vo.wa.grade.WaGradeVerVO;
import nc.vo.wa.grade.WaPsnhiBVO;

/**
 * нʱ׼Ӧ÷<BR>
 * <BR>
 * 
 * @author: xuhw
 * @date: 2009-11-10
 * @since: eHR V6.0
 * @߲:
 * @߲:
 * @޸:
 * @޸:
 */
public interface IWaGradeService
{
	/**
	 * ɾ
	 * 
	 * @author xuhw on 2009-11-11
	 * @param vo
	 * @throws BusinessException
	 */
	public abstract void deleteWaGradeVO(AggWaGradeVO vo) throws BusinessException;

	/**
	 * 
	 * 
	 * @author xuhw on 2009-11-11
	 * @param vo
	 * @return
	 * @throws BusinessException
	 */
	public abstract AggWaGradeVO insertWaGradeVO(AggWaGradeVO vo) throws BusinessException;

	/**
	 * 
	 * 
	 * @author xuhw on 2009-11-11
	 * @param vo
	 * @return
	 * @throws BusinessException
	 */
	public abstract AggWaGradeVO updateWaGradeVO(AggWaGradeVO vo) throws BusinessException;

	/**
	 * нʱ׼ֵ
	 * 
	 * @author xuhw on 2009-12-1
	 * @param wagradevo
	 * @param criterions
	 * @return
	 * @throws BusinessException
	 */
	public Object[] updateCriterionArray(WaGradeVO wagradevo, WaCriterionVO[] criterions) throws BusinessException;

	/**
	 * нԱֵ
	 * 
	 * @author xuhw on 2009-12-1
	 * @param wagradevo
	 * @param criterions
	 * @return
	 * @throws BusinessException
	 */
	public Object[] updateStdHiVOArray(WaGradeVO wagradevo, WaPsnhiBVO[] waStdHiVOs, int classType) throws BusinessException;

	/**
	 * 
	 * @param strPKPrmlv
	 * @param strPKSeclv
	 * @return
	 * @throws BusinessException
	 */
	public WaCriterionVO getCrierionVOByPrmSec(String strPKPrmlv, String strPKSeclv) throws BusinessException;

	/**
	 * 
	 * @param AdjustWadocVO[]
	 * @return
	 * @throws BusinessException
	 */
	public HashMap<String,WaCriterionVO> getCrierionVOMapByPrmSec(AdjustWadocVO[] adjustWadocPsnInfoVOs) throws BusinessException;

	/**
	 * 
	 * @param PsnappaproveVO
	 *            []
	 * @return
	 * @throws BusinessException
	 */
	public HashMap<String, WaCriterionVO> getCrierionVOMapByPrmSec(
			PsnappaproveBVO[] psnappaproveBVOs, boolean isApprove)
			throws BusinessException;

	/**
	 * нʱ׼
	 * 
	 * @param vervo
	 * @return
	 * @throws BusinessException
	 */
	public WaGradeVerVO processCriterionArray(WaGradeVO gradevo, WaGradeVerVO vervo)
			throws BusinessException;

	/**
	 * ƹ-нʱ׼
	 * @param gradevo
	 * @param vervo
	 * @return
	 * @throws BusinessException
	 */
	public WaGradeVerVO processCriterionArray4Copy(WaGradeVO gradevo, WaGradeVerVO vervo)
			throws BusinessException;

	/**
	 * ɾнʱ׼汾ݣɾӦнʱ׼
	 * 
	 * @param vervo
	 * @return
	 * @throws BusinessException
	 */
	public void deleteGradeVerVO(WaGradeVerVO vervo) throws BusinessException;


	/**
	 * ѯнʱ׼汾Ϣ BY gradePK
	 */
	public WaGradeVerVO[] queryGradeVerByGradePK(String strGradePk) throws BusinessException ;

	/**
	 * ѯЧнʱ׼汾Ϣ BY gradePK
	 */
	public WaGradeVerVO queryEffectGradeVerByGradePK(String strGradePk) throws BusinessException ;

	/**
	 * нʱ׼ѯнʱ׼汾汾
	 *
	 * @param strPKWaGrd
	 * @return
	 * @throws BusinessException
	 */
	public UFDouble getMaxVerNum(String strPKWaGrd) throws BusinessException;

	/**
	 * ɾнʱ׼汾¼PK
	 * @param strGradeVerPK
	 * @throws BusinessException
	 */
	public void deleteGradeVerByPk(String strGradeVerPK) throws BusinessException;

	/**
	 * нʱ׼Ӽ𵵱ʱ֤
	 *
	 * @param gradeVO
	 * @throws BusinessException
	 */
	public void validatorHasGradeVer(String strGradePK) throws BusinessException ;

	/**
	 * нʱ׼PKѯЧнʱ׼
	 * @param strPKGrade
	 * @return
	 * @throws BusinessException
	 */
	public WaCriterionVO[] getEffectCrierionsVOByGradePK(String strPKGrade) throws BusinessException;

	/**
	 * Унʱ׼Ƿ񱻺ҵã汾Ч־ǷΪУ飩
	 * @param strGradepk
	 * @throws BusinessException
	 */
	public String validateGradeHaveReferenceByBusiness(String strGradepk) throws BusinessException;

	/**
	 * Унʱ׼ǷЧ汾
	 * @param strGradepk
	 * @throws BusinessException
	 */
	public boolean validateEffectVersion(String strGradepk) throws BusinessException;

	/**
	 * ɾеļԱԺ͵Ա(޸ļԱԺ͵Ա)
	 * @param strGradepk
	 * @throws BusinessException
	 */
	public void deleteWaPsnhiByPK(String strGradepk, int classType) throws BusinessException;

	/**
	 * ɾʷδЧİ汾Ϣ(޸ʱǷ൵仯͵ɾʱ)
	 * @param strGradepk
	 * @throws BusinessException
	 */
	public void deleteVersionByGradePK(String strGradepk) throws BusinessException;

	/**
	 * Ա(Ʊ)
	 * @param strGradepk
	 * @throws BusinessException
	 */
	public void insertCopyStdHiVOArray(WaPsnhiBVO[] waStdHiVOs) throws BusinessException;

	/**
	 * нʱ׼
	 * @param waGradeOrgVOs
	 * @throws BusinessException
	 */
	public void insertWaGradeOrgVO(WaGradeOrgVO[] waGradeOrgVOs)throws BusinessException;
	
}
